program sdrCreateAnisoC
  ! Program to take output of the AnisoFit and create a appropriate sine wave showing the anisitropic behavior.
  
  use sep
  implicit none
  
  integer               :: n1,n2,n3,n4,nang
  real                  :: d1,d2,d3,d4
  real                  :: o1,o2,o3,o4
  
  real,allocatable      :: datain(:,:,:)
  real,allocatable      :: datout(:,:,:)
  
  integer               :: ii,jj,kk,ll
  character*50          :: label1,label2,label3,label4
  
  real,parameter        :: pi=3.14159265
  
  call sep_init()
  
  call from_history("n1",n1,1 )
  call from_history("n2",n2,1 )
  call from_history("n3",n3,1 )
  call from_history("n4",n4,1 )
  
  call from_history("d1",d1,1.)
  call from_history("d2",d2,1.)
  call from_history("d3",d3,1.)
  call from_history("d4",d4,1.)
  
  call from_history("o1",o1,0.)
  call from_history("o2",o2,0.)
  call from_history("o3",o3,0.)
  call from_history("o4",o4,0.)
  
  call from_history("label1",label1," ")
  call from_history("label2",label2," ")
  call from_history("label3",label3," ")
  call from_history("label4",label4," ")
  
  call from_param("nang",nang,n3)
  d3 = 2.*pi/(nang); o3 = -pi
  call to_history("n3",nang)
  call to_history("o3",o3)
  call to_history("d3",d3)
  
  call sep_close()
  
  ! Allocate
  allocate( datain(n1,n2,3   ) )
  allocate( datout(n1,n2,nang) )
  
  ! Read Average and Standaredeviation
  call sreed( "in", datain, 4*size(datain) )
  
  
  ! Calculate coordinates of dots
  do jj=1,n2
  do ii=1,n1
    do kk=1,nang
      datout(ii,jj,kk) = datain(ii,jj,1) + datain(ii,jj,2)*cos( 2* ((o3+(kk-1)*d3)-datain(ii,jj,3)) )
    end do
  end do
  end do
  
  ! Write out
  call srite("out",datout,4*size(datout) )
  
  ! Deallocate
  deallocate( datain )
  deallocate( datout )
  
end program
