program sdrEtomoAnisoCStatGraph
  ! Program to take output of a anisotropic program, azimuth and magnitude.
  ! And create vectors to be drawn with 'Graph'
  
  use sep
  implicit none
  
  integer               :: n1,n2,n3,n4
  real                  :: d1,d2,d3,d4
  real                  :: o1,o2,o3,o4
  
  real,allocatable      :: datain_ave(:,:,:,:)
  real,allocatable      :: datain_std(:,:,:,:)
  
  complex,allocatable   :: datout(:,:,:,:)
  
  integer               :: ii,jj,kk,ll
  character*50          :: label1,label2,label3,label4
  
  
  call sep_init()
  
  call from_history("n1",n1,1 )
  call from_history("n2",n2,1 )
  call from_history("n3",n3,1 )
  call from_history("n4",n4,1 )
  
  call from_history("d1",d1,1.)
  call from_history("d2",d2,1.)
  call from_history("d3",d3,1.)
  call from_history("d4",d4,1.)
  
  call from_history("o1",o1,0.)
  call from_history("o2",o2,0.)
  call from_history("o3",o3,0.)
  call from_history("o4",o4,0.)
  
  call from_history("label1",label1," ")
  call from_history("label2",label2," ")
  call from_history("label3",label3," ")
  call from_history("label4",label4," ")
  
  call to_history("d3",1.)
  call to_history("d4",1.)
  
  call to_history("o3",0.)
  call to_history("o4",0.)
  
  call to_history("esize",8)
  
  call sep_close()
  
  
  ! Allocate
  allocate( datain_ave(n1,n2,n3,1) )
  allocate( datain_std(n1,n2,n3,1) )
  allocate( datout    (n1,n2,n3,2) )
  
  ! Read Average and Standaredeviation
  call sreed( "in", datain_ave, 4*size(datain_ave) )
  call sreed( "in", datain_std, 4*size(datain_std) )
  
  
  ! Calculate coordinates of dots
  do jj=1,n2
  do ii=1,n1
    do kk=1,n3
      datout(ii,jj,kk,1) = cmplx( o3+(kk-1)*d3 , datain_ave(ii,jj,kk,1)-datain_std(ii,jj,kk,1) )
      datout(ii,jj,kk,2) = cmplx( o3+(kk-1)*d3 , datain_ave(ii,jj,kk,1)+datain_std(ii,jj,kk,1) ) 
    end do
  end do
  end do

  ! Write out
  call srite("out",datout,8*size(datout) )
  
  ! Deallocate
  deallocate( datain_ave )
  deallocate( datain_std )
  deallocate( datout     )
  
end program
