program sdrMakeSparse

  use sep
  implicit none
  
  integer               :: n1,n2,n3,n4,n5,n6
  real                  :: d1,d2,d3,d4,d5,d6
  real                  :: o1,o2,o3,o4,o5,o6
  
  integer               :: n1h,n2h,n3h,n4h,n5h,n6h
  real                  :: d1h,d2h,d3h,d4h,d5h,d6h
  real                  :: o1h,o2h,o3h,o4h,o5h,o6h
  
  integer               :: cnt
  
  integer               :: ii,jj,kk,ll,mm,nn
  
  real,allocatable      :: dat(:)
  real,allocatable      :: hdr(:)
  
  call sep_init()
  
  call from_history("n1",n1,1 )
  call from_history("n2",n2,1 )
  call from_history("n3",n3,1 )
  call from_history("n4",n4,1 )
  call from_history("n5",n5,1 )
  call from_history("n6",n6,1 )
  
  call from_history("d1",d1,1.)
  call from_history("d2",d2,1.)
  call from_history("d3",d3,1.)
  call from_history("d4",d4,1.)
  call from_history("d5",d5,1.)
  call from_history("d6",d6,1.)
  
  call from_history("o1",o1,0.)
  call from_history("o2",o2,0.)
  call from_history("o3",o3,0.)
  call from_history("o4",o4,0.)
  call from_history("o5",o5,0.)
  call from_history("o6",o6,0.)
  
  if (exist_file('hdr_in')) then
  call from_aux("hdr_in","n1",n1h,1 )
  call from_aux("hdr_in","n2",n2h,1 )
  call from_aux("hdr_in","n3",n3h,1 )
  call from_aux("hdr_in","n4",n4h,1 )
  call from_aux("hdr_in","n5",n5h,1 )
  call from_aux("hdr_in","n6",n6h,1 )
  
  call from_aux("hdr_in","d1",d1h,1.)
  call from_aux("hdr_in","d2",d2h,1.)
  call from_aux("hdr_in","d3",d3h,1.)
  call from_aux("hdr_in","d4",d4h,1.)
  call from_aux("hdr_in","d5",d5h,1.)
  call from_aux("hdr_in","d6",d6h,1.)
  
  call from_aux("hdr_in","o1",o1h,0.)
  call from_aux("hdr_in","o2",o2h,0.)
  call from_aux("hdr_in","o3",o3h,0.)
  call from_aux("hdr_in","o4",o4h,0.)
  call from_aux("hdr_in","o5",o5h,0.)
  call from_aux("hdr_in","o6",o6h,0.)
  end if

 ! write(0,*) "n1 ,n2 ,n3 ,n4 ,n5 ,n6"
 ! write(0,*)  n1 ,n2 ,n3 ,n4 ,n5 ,n6
 ! write(0,*) "n1h,n2h,n3h,n4h,n5h,n6h"
 ! write(0,*)  n1h,n2h,n3h,n4h,n5h,n6h

  cnt=0
  allocate(dat(n1))
  if (exist_file('hdr_in')) then; allocate(hdr(n1h)); end if
  
  do nn=1,n6
  do mm=1,n5
  do ll=1,n4
  
  do kk=1,n3
  do jj=1,n2

 ! write(0,*) "trace:", (nn-1)*n3*n4*n5*n6+(mm-1)**n3*n4*n5+(ll-1)*n3*n4+(kk-1)*n3+jj
  
  ! Empty data and headers
  dat = 0.; hdr = 0.
  
  ! Read data and headers
  call sreed("in"    ,dat,4*n1 )
  if (exist_file('hdr_in')) then;  call sreed("hdr_in",hdr,4*n1h);  end if
  
  ! Test if empty
  if (sum(abs(dat)).ne.0.) then
 !   write(0,*) "done"
    cnt = cnt + 1             ! Increase counter
    call srite("out"    ,dat,4*n1 )
  if (exist_file('hdr_out')) then;      call srite("hdr_out",hdr,4*n1h);  end if
  end if
  
  end do
  end do
  
  end do
  end do
  end do
  
  write(0,*) "Found",cnt,"traces"

  ! Adapt headers
  call to_history("n1",n1 ,"out")
  call to_history("n2",cnt,"out")
  call to_history("n3",n3 ,"out")
  call to_history("n4",n4 ,"out")
  call to_history("n5",n5 ,"out")
  call to_history("n6",n6 ,"out")
  
  call to_history("d1",d1,"out")
  call to_history("d2",d2,"out")
  call to_history("d3",d3,"out")
  call to_history("d4",d4,"out")
  call to_history("d5",d5,"out")
  call to_history("d6",d6,"out")
  
  call to_history("o1",o1,"out")
  call to_history("o2",o2,"out")
  call to_history("o3",o3,"out")
  call to_history("o4",o4,"out")
  call to_history("o5",o5,"out")
  call to_history("o6",o6,"out")
  
  ! Adapt headers
  if (exist_file('hdr_out')) then;
  call to_history("n1",n1h,"hdr_out")
  call to_history("n2",cnt,"hdr_out")
  call to_history("n3",n3h,"hdr_out")
  call to_history("n4",n4h,"hdr_out")
  call to_history("n5",n5h,"hdr_out")
  call to_history("n6",n6h,"hdr_out")
  
  call to_history("d1",d1h,"hdr_out")
  call to_history("d2",d2h,"hdr_out")
  call to_history("d3",d3h,"hdr_out")
  call to_history("d4",d4h,"hdr_out")
  call to_history("d5",d5h,"hdr_out")
  call to_history("d6",d6h,"hdr_out")
  
  call to_history("o1",o1h,"hdr_out")
  call to_history("o2",o2h,"hdr_out")
  call to_history("o3",o3h,"hdr_out")
  call to_history("o4",o4h,"hdr_out")
  call to_history("o5",o5h,"hdr_out")
  call to_history("o6",o6h,"hdr_out")
  end if

  deallocate(dat)
  if (exist_file('hdr')) then; deallocate(hdr); end if
  call sep_close()
  call exit(0)

end program
