program sdrMaxloc_old
  ! Applies Fortran Maxloc
  ! optional params:
  ! indices = [F]/T   (find indices instead of axis defined value)
  ! choose  = [first],last (choose first or last)
  ! abs     = [F]/T
  
  use sep
  implicit none
  
  real,allocatable :: data(:)
  real             :: value
  integer          :: n1,n2,n3,n4,n5,n6
  real             :: d1,d2,d3,d4,d5,d6
  real             :: o1,o2,o3,o4,o5,o6
  integer          :: ii,jj,kk,ll,mm,nn
  character*50     :: label1,label2,label3
  character*50     :: label4,label5,label6
  
  character*50     :: choose
  logical          :: first,indices,absol,mabsol
  
  
  call sep_init()
  
  call from_history("n1",n1,1 )
  call from_history("n2",n2,1 )
  call from_history("n3",n3,1 )
  call from_history("n4",n4,1 )
  call from_history("n5",n5,1 )
  call from_history("n6",n6,1 )

  call from_history("d1",d1,1.)
  call from_history("d2",d2,1.)
  call from_history("d3",d3,1.)
  call from_history("d4",d4,1.)
  call from_history("d5",d5,1.)
  call from_history("d6",d6,1.)

  call from_history("o1",o1,0.)
  call from_history("o2",o2,0.)
  call from_history("o3",o3,0.)
  call from_history("o4",o4,0.)
  call from_history("o5",o5,0.)
  call from_history("o6",o6,0.)
  
  call from_history("label1",label1,' ')
  call from_history("label2",label2,' ')
  call from_history("label3",label3,' ')
  call from_history("label4",label4,' ')
  call from_history("label5",label5,' ')
  call from_history("label6",label6,' ')
  
  
  write(0,*) 'n1,n2,n3,n4,n5,n6'
  write(0,*)  n1,n2,n3,n4,n5,n6
  
  call from_param( 'choose', choose,'first')   ! Always choose the first index of maxima
  call from_param('indices',indices,.false.)   ! Get indixes instead of axis values
  call from_param('abs'    ,absol  ,.false.)   ! get absolute value of axis values
  call from_param('mabs'   ,mabsol ,.false.)   ! Get begative of abolute value
  
  if (choose.eq.'first') then;    first = .true.
  else;                           first = .false.
  end if

  if (absol.and.mabsol) then
    mabsol = .false.
  end if
  
  write(0,*) 'indices,first'
  write(0,*)  indices,first

  
  call to_history("n1",1)
  call to_history("n2",n2)
  call to_history("n3",n3)
  call to_history("n5",n4)
  call to_history("n6",n5)
  call to_history("n7",n6)

!  call to_history("d1",d2)
!  call to_history("d2",d3)
!  call to_history("d3",d4)
!  call to_history("d4",d5)
!  call to_history("d5",d6)
!  call to_history("d6",1.)

!  call to_history("o1",o2)
!  call to_history("o2",o3)
!  call to_history("o3",o4)
!  call to_history("o4",o5)
!  call to_history("o5",o6)
!  call to_history("o6",0.)

!  call to_history("label1",label2)
!  call to_history("label2",label3)
!  call to_history("label3",label4)
!  call to_history("label4",label5)
!  call to_history("label5",label6)
!  call to_history("label6",' ')

  call sep_close()
  
  
  allocate( data(n1) )


  if (indices.and.first.and..not.absol) then
    do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
      call sreed("in",data,4*n1)
      value = minval(maxloc(data))
      call srite("out",value,4 )
    end do;      end do;      end do;      end do;      end do
  end if
  
  if (indices.and..not.first.and..not.absol) then
    do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
      call sreed("in",data,4*n1)
      value = maxval(maxloc(data))
      call srite("out",value,4 )
    end do;      end do;      end do;      end do;      end do
  end if
  
  if (.not.indices.and.first.and..not.absol) then
    do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
      call sreed("in",data,4*n1)
      value = o1+(minval(maxloc(data))-1)*d1
      call srite("out",value,4 )
    end do;      end do;      end do;      end do;      end do
  end if
  
  if (.not.indices.and..not.first.and..not.absol) then
    do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
      call sreed("in",data,4*n1)
      value = o1+(maxval(maxloc(data))-1)*d1
      call srite("out",value,4 )
    end do;      end do;      end do;      end do;      end do
  end if
  




  if (indices.and.first.and.absol) then
    do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
      call sreed("in",data,4*n1)
      value = minval(maxloc(data))
      call srite("out",abs(value),4 )
    end do;      end do;      end do;      end do;      end do
  end if
  
  if (indices.and..not.first.and.absol) then
    do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
      call sreed("in",data,4*n1)
      value = maxval(maxloc(data))
      call srite("out",abs(value),4 )
    end do;      end do;      end do;      end do;      end do
  end if
  
  if (.not.indices.and.first.and.absol) then
    do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
      call sreed("in",data,4*n1)
      value = o1+(minval(maxloc(data))-1)*d1
      call srite("out",abs(value),4 )
    end do;      end do;      end do;      end do;      end do
  end if
  
  if (.not.indices.and..not.first.and.absol) then
    do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
      call sreed("in",data,4*n1)
      value = o1+(maxval(maxloc(data))-1)*d1
      call srite("out",abs(value),4 )
    end do;      end do;      end do;      end do;      end do
  end if


  if (indices.and.first.and.mabsol) then
    do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
      call sreed("in",data,4*n1)
      value = minval(maxloc(data))
      call srite("out",-abs(value),4 )
    end do;      end do;      end do;      end do;      end do
  end if
  
  if (indices.and..not.first.and.mabsol) then
    do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
      call sreed("in",data,4*n1)
      value = maxval(maxloc(data))
      call srite("out",-abs(value),4 )
    end do;      end do;      end do;      end do;      end do
  end if
  
  if (.not.indices.and.first.and.mabsol) then
    do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
      call sreed("in",data,4*n1)
      value = o1+(minval(maxloc(data))-1)*d1
      call srite("out",-abs(value),4 )
    end do;      end do;      end do;      end do;      end do
  end if
  
  if (.not.indices.and..not.first.and.mabsol) then
    do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
      call sreed("in",data,4*n1)
      value = o1+(maxval(maxloc(data))-1)*d1
      call srite("out",-abs(value),4 )
    end do;      end do;      end do;      end do;      end do
  end if

  
  deallocate( data )

end program
