program sdrRMSxyz
  ! Program to compute RMS values for values along 1st dimension
  
  
  use sep
  implicit none
  
  integer                     ::  n1, n2, n3, n4, n5
  real                        ::  d1, d2, d3, d4, d5
  real                        ::  o1, o2, o3, o4, o5
  
  integer                     :: xn1,xn2,xn3,xn4,xn5
  real                        :: xd1,xd2,xd3,xd4,xd5
  real                        :: xo1,xo2,xo3,xo4,xo5
  
  integer                     :: yn1,yn2,yn3,yn4,yn5
  real                        :: yd1,yd2,yd3,yd4,yd5
  real                        :: yo1,yo2,yo3,yo4,yo5
  
  integer                     :: zn1,zn2,zn3,zn4,zn5
  real                        :: zd1,zd2,zd3,zd4,zd5
  real                        :: zo1,zo2,zo3,zo4,zo5
  
  character*50                ::  label1, label2, label3, label4, label5
  character*50                :: xlabel1,xlabel2,xlabel3,xlabel4,xlabel5
  character*50                :: ylabel1,ylabel2,ylabel3,ylabel4,ylabel5
  character*50                :: zlabel1,zlabel2,zlabel3,zlabel4,zlabel5
  
  integer                     :: ii,jj,kk,ll,mm
  
  real,allocatable            :: x(:),y(:),z(:),dataout(:)
  
  
  call sep_init()

  if (exist_file("x")) then
  call from_aux("x","n1",n1,1 )
  call from_aux("x","n2",n2,1 )
  call from_aux("x","n3",n3,1 )
  call from_aux("x","n4",n4,1 )
  call from_aux("x","n5",n5,1 )

  call from_aux("x","d1",d1,1.)
  call from_aux("x","d2",d2,1.)
  call from_aux("x","d3",d3,1.)
  call from_aux("x","d4",d4,1.)
  call from_aux("x","d5",d5,1.)

  call from_aux("x","o1",o1,0.)
  call from_aux("x","o2",o2,0.)
  call from_aux("x","o3",o3,0.)
  call from_aux("x","o4",o4,0.)
  call from_aux("x","o5",o5,0.)

  call from_aux("x","label1",label1,' ')
  call from_aux("x","label2",label2,' ')
  call from_aux("x","label3",label3,' ')
  call from_aux("x","label4",label4,' ')
  call from_aux("x","label5",label5,' ')
  end if

  if (exist_file("y")) then
  call from_aux("y","n1",yn1,1 )
  call from_aux("y","n2",yn2,1 )
  call from_aux("y","n3",yn3,1 )
  call from_aux("y","n4",yn4,1 )
  call from_aux("y","n5",yn5,1 )

  call from_aux("y","d1",yd1,1.)
  call from_aux("y","d2",yd2,1.)
  call from_aux("y","d3",yd3,1.)
  call from_aux("y","d4",yd4,1.)
  call from_aux("y","d5",yd5,1.)

  call from_aux("y","o1",yo1,0.)
  call from_aux("y","o2",yo2,0.)
  call from_aux("y","o3",yo3,0.)
  call from_aux("y","o4",yo4,0.)
  call from_aux("y","o5",yo5,0.)

  call from_aux("y","label1",ylabel1,' ')
  call from_aux("y","label2",ylabel2,' ')
  call from_aux("y","label3",ylabel3,' ')
  call from_aux("y","label4",ylabel4,' ')
  call from_aux("y","label5",ylabel5,' ')
  end if

  if (exist_file("z")) then
  call from_aux("z","n1",zn1,1 )
  call from_aux("z","n2",zn2,1 )
  call from_aux("z","n3",zn3,1 )
  call from_aux("z","n4",zn4,1 )
  call from_aux("z","n5",zn5,1 )

  call from_aux("z","d1",zd1,1.)
  call from_aux("z","d2",zd2,1.)
  call from_aux("z","d3",zd3,1.)
  call from_aux("z","d4",zd4,1.)
  call from_aux("z","d5",zd5,1.)
  
  call from_aux("z","o1",zo1,0.)
  call from_aux("z","o2",zo2,0.)
  call from_aux("z","o3",zo3,0.)
  call from_aux("z","o4",zo4,0.)
  call from_aux("z","o5",zo5,0.)
  
  call from_aux("z","label1",zlabel1,' ')
  call from_aux("z","label2",zlabel2,' ')
  call from_aux("z","label3",zlabel3,' ')
  call from_aux("z","label4",zlabel4,' ')
  call from_aux("z","label5",zlabel5,' ')
  end if
  
  if (exist_file("x")) then
    n1 = xn1; n2 = xn2; n3 = xn3; n4 = xn4; n5 = xn5
    d1 = xd1; d2 = xd2; d3 = xd3; d4 = xd4; d5 = xd5
    o1 = xo1; o2 = xo2; o3 = xo3; o4 = xo4; o5 = xo5
    label1=xlabel1; label2=xlabel2; label3=xlabel3; label4=xlabel4; label5=xlabel5
  else if(exist_file("z")) then
    n1 = yn1; n2 = yn2; n3 = yn3; n4 = yn4; n5 = yn5
    d1 = yd1; d2 = yd2; d3 = yd3; d4 = yd4; d5 = yd5
    o1 = yo1; o2 = yo2; o3 = yo3; o4 = yo4; o5 = yo5
    label1=ylabel1; label2=ylabel2; label3=ylabel3; label4=ylabel4; label5=ylabel5
  else if(exist_file("z")) then
    n1 = zn1; n2 = zn2; n3 = zn3; n4 = zn4; n5 = zn5
    d1 = zn1; d2 = zd2; d3 = zd3; d4 = zd4; d5 = zd5
    o1 = zo1; o2 = zo2; o3 = zo3; o4 = zo4; o5 = zo5
    label1=zlabel1; label2=zlabel2; label3=zlabel3; label4=zlabel4; label5=zlabel5
  else
    n1 = 1 ; n2 = 1 ; n3 = 1;  n4 = 1 ; n5 = 1
    d1 = 1.; d2 = 1.; d3 = 1.; d4 = 1.; d5 = 1.
    o1 = 0.; o2 = 0.; o3 = 0.; o4 = 0.; o5 = 0.
    label1=' '; label2=' '; label3=' '; label4=' '; label5=' '
  end if
  
  if (exist_file("x").and.exist_file("y").and.exist_file("z")) then
    if (n1.ne.xn1 .or. n1.ne.yn1 .or. n1.ne.zn1) then; write(0,*) 'n1.ne.xn1 .or. n1.ne.yn1 .or. n1.ne.zn1'; call exit(0); end if
    if (n2.ne.xn2 .or. n2.ne.yn2 .or. n2.ne.zn2) then; write(0,*) 'n2.ne.xn2 .or. n2.ne.yn2 .or. n2.ne.zn2'; call exit(0); end if
    if (n3.ne.xn3 .or. n3.ne.yn3 .or. n3.ne.zn3) then; write(0,*) 'n3.ne.xn3 .or. n3.ne.yn3 .or. n3.ne.zn3'; call exit(0); end if
    if (n4.ne.xn4 .or. n4.ne.yn4 .or. n4.ne.zn4) then; write(0,*) 'n4.ne.xn4 .or. n4.ne.yn4 .or. n4.ne.zn4'; call exit(0); end if
    if (n5.ne.xn5 .or. n5.ne.yn5 .or. n5.ne.zn5) then; write(0,*) 'n5.ne.xn5 .or. n5.ne.yn5 .or. n5.ne.zn5'; call exit(0); end if
  end if
  
  if (exist_file("x").and.exist_file("y").and..not.exist_file("z")) then
    if (n1.ne.xn1 .or. n1.ne.yn1) then;  write(0,*) 'n1.ne.xn1 .or. n1.ne.yn1';  call exit(0);  end if
    if (n2.ne.xn2 .or. n2.ne.yn2) then;  write(0,*) 'n2.ne.xn2 .or. n2.ne.yn2';  call exit(0);  end if
    if (n3.ne.xn3 .or. n3.ne.yn3) then;  write(0,*) 'n3.ne.xn3 .or. n3.ne.yn3';  call exit(0);  end if
    if (n4.ne.xn4 .or. n4.ne.yn4) then;  write(0,*) 'n4.ne.xn4 .or. n4.ne.yn4';  call exit(0);  end if
    if (n5.ne.xn5 .or. n5.ne.yn5) then;  write(0,*) 'n5.ne.xn5 .or. n5.ne.yn5';  call exit(0);  end if
  end if
  
  if (exist_file("x").and..not.exist_file("y").and.exist_file("z")) then
    if (n1.ne.xn1 .or. n1.ne.zn1) then;  write(0,*) 'n1.ne.xn1 .or. n1.ne.zn1';  call exit(0);  end if
    if (n2.ne.xn2 .or. n2.ne.zn2) then;  write(0,*) 'n2.ne.xn2 .or. n2.ne.zn2';  call exit(0);  end if
    if (n3.ne.xn3 .or. n3.ne.zn3) then;  write(0,*) 'n3.ne.xn3 .or. n3.ne.zn3';  call exit(0);  end if
    if (n4.ne.xn4 .or. n4.ne.zn4) then;  write(0,*) 'n4.ne.xn4 .or. n4.ne.zn4';  call exit(0);  end if
    if (n5.ne.xn5 .or. n5.ne.zn5) then;  write(0,*) 'n5.ne.xn5 .or. n5.ne.zn5';  call exit(0);  end if
  end if
  
  if (.not.exist_file("x").and.exist_file("y").and.exist_file("z")) then
    if (n1.ne.yn1 .or. n1.ne.zn1) then;  write(0,*) 'n1.ne.yn1 .or. n1.ne.zn1';  call exit(0);  end if
    if (n2.ne.yn2 .or. n2.ne.zn2) then;  write(0,*) 'n2.ne.yn2 .or. n2.ne.zn2';  call exit(0);  end if
    if (n3.ne.yn3 .or. n3.ne.zn3) then;  write(0,*) 'n3.ne.yn3 .or. n3.ne.zn3';  call exit(0);  end if
    if (n4.ne.yn4 .or. n4.ne.zn4) then;  write(0,*) 'n4.ne.yn4 .or. n4.ne.zn4';  call exit(0);  end if
    if (n5.ne.yn5 .or. n5.ne.zn5) then;  write(0,*) 'n5.ne.yn5 .or. n5.ne.zn5';  call exit(0);  end if
  end if
  
  
  call to_history("n1",n1 )
  call to_history("n2",n2 )
  call to_history("n3",n3 )
  call to_history("n4",n4 )
  call to_history("n5",n5 )
  
  call to_history("d1",d1)
  call to_history("d2",d2)
  call to_history("d3",d3)
  call to_history("d4",d4)
  call to_history("d5",d5)
  
  call to_history("o1",o1)
  call to_history("o2",o2)
  call to_history("o3",o3)
  call to_history("o4",o4)
  call to_history("o5",o5)
  
  call to_history("label1",label1)
  call to_history("label2",label2)
  call to_history("label3",label3)
  call to_history("label4",label4)
  call to_history("label5",label5)
  
  call sep_close()
  
  allocate(x(n1),y(n1),z(n1),dataout(n1))
  
  ! Read data
  do mm=1,n5
  do ll=1,n4
  do kk=1,n3
  do jj=1,n2

    dataout = 0.
    if (exist_file("x")) then;  call sreed("x",x,4*n1);  else;  x = 0.;  end if
    if (exist_file("y")) then;  call sreed("y",y,4*n1);  else;  y = 0.;  end if
    if (exist_file("z")) then;  call sreed("z",z,4*n1);  else;  z = 0.;  end if
    do ii=1,n1
      dataout(ii) = sqrt( x(ii)**2.+y(ii)**2.+z(ii)**2. )
    end do
    call srite("out",dataout,4*n1)

  end do
  end do
  end do
  end do
  
  
  call exit(0)

end program
