program sdrSIaverage
  ! Program to trace-by-trace average a set of input files (up to 9), up to 6 dims
  
  use sep
  implicit none
  
  real                       :: d1,d2,d3,d4,d5,d6
  real                       :: o1,o2,o3,o4,o5,o6
  character*50               :: label1,label2,label3
  character*50               :: label4,label5,label6
  character*50               :: label7,label8,label9
  character*50               :: label10,label11,label12
  character*50               :: label13,label14,label15
  
  integer                    :: n1 ,n2 ,n3 ,n4 ,n5 ,n6
  integer                    :: n11,n21,n31,n41,n51,n61
  integer                    :: n12,n22,n32,n42,n52,n62
  integer                    :: n13,n23,n33,n43,n53,n63
  integer                    :: n14,n24,n34,n44,n54,n64
  integer                    :: n15,n25,n35,n45,n55,n65
  integer                    :: n16,n26,n36,n46,n56,n66
  integer                    :: n17,n27,n37,n47,n57,n67
  integer                    :: n18,n28,n38,n48,n58,n68
  integer                    :: n19,n29,n39,n49,n59,n69
  integer                    :: n110,n210,n310,n410,n510,n610
  integer                    :: n111,n211,n311,n411,n511,n611
  integer                    :: n112,n212,n312,n412,n512,n612
  integer                    :: n113,n213,n313,n413,n513,n613
  integer                    :: n114,n214,n314,n414,n514,n614
  integer                    :: n115,n215,n315,n415,n515,n615
  
  real,allocatable           :: trace (:)
  real,allocatable           :: trace1(:),trace2(:),trace3(:)
  real,allocatable           :: trace4(:),trace5(:),trace6(:)
  real,allocatable           :: trace7(:),trace8(:),trace9(:)
  real,allocatable           :: trace10(:),trace11(:),trace12(:)
  real,allocatable           :: trace13(:),trace14(:),trace15(:)


  integer                    :: ii,jj,kk,ll,mm,nn,oo,pp,qq,rr,ss,tt,uu,vv,ww,nfiles
  
  logical                    :: norm
  real                       :: normval
  
  call sep_init()
  
  call from_param("nfiles",nfiles,1)
  
  call from_param("normalize",norm,.true.)

  call from_aux("file1","n1",n11,1 )
  call from_aux("file1","n2",n21,1 )
  call from_aux("file1","n3",n31,1 )
  call from_aux("file1","n4",n41,1 )
  call from_aux("file1","n5",n51,1 )
  call from_aux("file1","n6",n61,1 )
  
  call from_aux("file1","d1",d1,1.)
  call from_aux("file1","d2",d2,1.)
  call from_aux("file1","d3",d3,1.)
  call from_aux("file1","d4",d4,1.)
  call from_aux("file1","d5",d5,1.)
  call from_aux("file1","d6",d6,1.)
  
  call from_aux("file1","o1",o1,0.)
  call from_aux("file1","o2",o2,0.)
  call from_aux("file1","o3",o3,0.)
  call from_aux("file1","o4",o4,0.)
  call from_aux("file1","o5",o5,0.)
  call from_aux("file1","o6",o6,0.)
  
  call from_aux("file2","n1",n12,1 )
  call from_aux("file2","n2",n22,1 )
  call from_aux("file2","n3",n32,1 )
  call from_aux("file2","n4",n42,1 )
  call from_aux("file2","n5",n52,1 )
  call from_aux("file2","n6",n62,1 )
  
  if (nfiles.ge.3) then
  call from_aux("file3","n1",n13,1 )
  call from_aux("file3","n2",n23,1 )
  call from_aux("file3","n3",n33,1 )
  call from_aux("file3","n4",n43,1 )
  call from_aux("file3","n5",n53,1 )
  call from_aux("file3","n6",n63,1 )
  end if
  
  if (nfiles.ge.4) then
  call from_aux("file4","n1",n14,1 )
  call from_aux("file4","n2",n24,1 )
  call from_aux("file4","n3",n34,1 )
  call from_aux("file4","n4",n44,1 )
  call from_aux("file4","n5",n54,1 )
  call from_aux("file4","n6",n64,1 )
  end if
  
  if (nfiles.ge.5) then
  call from_aux("file5","n1",n15,1 )
  call from_aux("file5","n2",n25,1 )
  call from_aux("file5","n3",n35,1 )
  call from_aux("file5","n4",n45,1 )
  call from_aux("file5","n5",n55,1 )
  call from_aux("file5","n6",n65,1 )
  end if
  
  if (nfiles.ge.6) then
  call from_aux("file6","n1",n16,1 )
  call from_aux("file6","n2",n26,1 )
  call from_aux("file6","n3",n36,1 )
  call from_aux("file6","n4",n46,1 )
  call from_aux("file6","n5",n56,1 )
  call from_aux("file6","n6",n66,1 )
  end if

  if (nfiles.ge.7) then
  call from_aux("file7","n1",n17,1 )
  call from_aux("file7","n2",n27,1 )
  call from_aux("file7","n3",n37,1 )
  call from_aux("file7","n4",n47,1 )
  call from_aux("file7","n5",n57,1 )
  call from_aux("file7","n6",n67,1 )
  end if

  if (nfiles.ge.8) then
  call from_aux("file8","n1",n18,1 )
  call from_aux("file8","n2",n28,1 )
  call from_aux("file8","n3",n38,1 )
  call from_aux("file8","n4",n48,1 )
  call from_aux("file8","n5",n58,1 )
  call from_aux("file8","n6",n68,1 )
  end if

  if (nfiles.ge.9) then
  call from_aux("file9","n1",n19,1 )
  call from_aux("file9","n2",n29,1 )
  call from_aux("file9","n3",n39,1 )
  call from_aux("file9","n4",n49,1 )
  call from_aux("file9","n5",n59,1 )
  call from_aux("file9","n6",n69,1 )
  end if

  if (nfiles.ge.10) then
  call from_aux("file10","n1",n110,1 )
  call from_aux("file10","n2",n210,1 )
  call from_aux("file10","n3",n310,1 )
  call from_aux("file10","n4",n410,1 )
  call from_aux("file10","n5",n510,1 )
  call from_aux("file10","n6",n610,1 )
  end if


  if (nfiles.ge.11) then
  call from_aux("file11","n1",n111,1 )
  call from_aux("file11","n2",n211,1 )
  call from_aux("file11","n3",n311,1 )
  call from_aux("file11","n4",n411,1 )
  call from_aux("file11","n5",n511,1 )
  call from_aux("file11","n6",n611,1 )
  end if


  if (nfiles.ge.12) then
  call from_aux("file12","n1",n112,1 )
  call from_aux("file12","n2",n212,1 )
  call from_aux("file12","n3",n312,1 )
  call from_aux("file12","n4",n412,1 )
  call from_aux("file12","n5",n512,1 )
  call from_aux("file12","n6",n612,1 )
  end if


  if (nfiles.ge.13) then
  call from_aux("file13","n1",n113,1 )
  call from_aux("file13","n2",n213,1 )
  call from_aux("file13","n3",n313,1 )
  call from_aux("file13","n4",n413,1 )
  call from_aux("file13","n5",n513,1 )
  call from_aux("file13","n6",n613,1 )
  end if


  if (nfiles.ge.14) then
  call from_aux("file14","n1",n114,1 )
  call from_aux("file14","n2",n214,1 )
  call from_aux("file14","n3",n314,1 )
  call from_aux("file14","n4",n414,1 )
  call from_aux("file14","n5",n514,1 )
  call from_aux("file14","n6",n614,1 )
  end if


  if (nfiles.ge.15) then
  call from_aux("file15","n1",n115,1 )
  call from_aux("file15","n2",n215,1 )
  call from_aux("file15","n3",n315,1 )
  call from_aux("file15","n4",n415,1 )
  call from_aux("file15","n5",n515,1 )
  call from_aux("file15","n6",n615,1 )
  end if

 ! write(0,*) "n11,n21,n31,n41,n51,n61",n11,n21,n31,n41,n51,n61
 ! write(0,*) "n12,n22,n32,n42,n52,n62",n12,n22,n32,n42,n52,n62
 ! write(0,*) "n13,n23,n33,n43,n53,n63",n13,n23,n33,n43,n53,n63


  ! Error checks
  if (n11.eq.n12) then; n1=n11; else; write(0,*) 'n11.ne.n12'; call exit(0); end if
  if (n21.eq.n22) then; n2=n21; else; write(0,*) 'n21.ne.n22'; call exit(0); end if
  if (n31.eq.n32) then; n3=n31; else; write(0,*) 'n31.ne.n32'; call exit(0); end if
  if (n41.eq.n42) then; n4=n41; else; write(0,*) 'n41.ne.n42'; call exit(0); end if
  if (n51.eq.n52) then; n5=n51; else; write(0,*) 'n51.ne.n52'; call exit(0); end if
  if (n61.eq.n62) then; n6=n61; else; write(0,*) 'n61.ne.n62'; call exit(0); end if

  if (nfiles.ge.3) then
  if (n12.ne.n13) then; write(0,*) 'n12.ne.n13'; call exit(0); end if
  if (n22.ne.n23) then; write(0,*) 'n22.ne.n23'; call exit(0); end if
  if (n32.ne.n33) then; write(0,*) 'n32.ne.n33'; call exit(0); end if
  if (n42.ne.n43) then; write(0,*) 'n42.ne.n43'; call exit(0); end if
  if (n52.ne.n53) then; write(0,*) 'n52.ne.n53'; call exit(0); end if
  if (n62.ne.n63) then; write(0,*) 'n62.ne.n63'; call exit(0); end if
  end if
 
  if (nfiles.ge.4) then
  if (n13.ne.n14) then; write(0,*) 'n13.ne.n14'; call exit(0); end if
  if (n23.ne.n24) then; write(0,*) 'n23.ne.n24'; call exit(0); end if
  if (n33.ne.n34) then; write(0,*) 'n33.ne.n34'; call exit(0); end if
  if (n43.ne.n44) then; write(0,*) 'n43.ne.n44'; call exit(0); end if
  if (n53.ne.n54) then; write(0,*) 'n53.ne.n54'; call exit(0); end if
  if (n63.ne.n64) then; write(0,*) 'n63.ne.n64'; call exit(0); end if
  end if
  
  if (nfiles.ge.5) then
  if (n14.ne.n15) then; write(0,*) 'n14.ne.n15'; call exit(0); end if
  if (n24.ne.n25) then; write(0,*) 'n24.ne.n25'; call exit(0); end if
  if (n34.ne.n35) then; write(0,*) 'n34.ne.n35'; call exit(0); end if
  if (n44.ne.n45) then; write(0,*) 'n44.ne.n45'; call exit(0); end if
  if (n54.ne.n55) then; write(0,*) 'n54.ne.n55'; call exit(0); end if
  if (n64.ne.n65) then; write(0,*) 'n64.ne.n65'; call exit(0); end if
  end if
  
  if (nfiles.ge.6) then
  if (n15.ne.n16) then; write(0,*) 'n15.ne.n16'; call exit(0); end if
  if (n25.ne.n26) then; write(0,*) 'n25.ne.n26'; call exit(0); end if
  if (n35.ne.n36) then; write(0,*) 'n35.ne.n36'; call exit(0); end if
  if (n45.ne.n46) then; write(0,*) 'n45.ne.n46'; call exit(0); end if
  if (n55.ne.n56) then; write(0,*) 'n55.ne.n56'; call exit(0); end if
  if (n65.ne.n66) then; write(0,*) 'n65.ne.n66'; call exit(0); end if
  end if

  if (nfiles.ge.7) then
  if (n16.ne.n17) then; write(0,*) 'n16.ne.n17'; call exit(0); end if
  if (n26.ne.n27) then; write(0,*) 'n26.ne.n27'; call exit(0); end if
  if (n36.ne.n37) then; write(0,*) 'n36.ne.n37'; call exit(0); end if
  if (n46.ne.n47) then; write(0,*) 'n46.ne.n47'; call exit(0); end if
  if (n56.ne.n57) then; write(0,*) 'n56.ne.n57'; call exit(0); end if
  if (n66.ne.n67) then; write(0,*) 'n66.ne.n67'; call exit(0); end if
  end if

  if (nfiles.ge.8) then
  if (n17.ne.n18) then; write(0,*) 'n17.ne.n18'; call exit(0); end if
  if (n27.ne.n28) then; write(0,*) 'n27.ne.n28'; call exit(0); end if
  if (n37.ne.n38) then; write(0,*) 'n37.ne.n38'; call exit(0); end if
  if (n47.ne.n48) then; write(0,*) 'n47.ne.n48'; call exit(0); end if
  if (n57.ne.n58) then; write(0,*) 'n57.ne.n58'; call exit(0); end if
  if (n67.ne.n68) then; write(0,*) 'n67.ne.n68'; call exit(0); end if
  end if

  if (nfiles.ge.9) then
  if (n18.ne.n19) then; write(0,*) 'n18.ne.n19'; call exit(0); end if
  if (n28.ne.n29) then; write(0,*) 'n28.ne.n29'; call exit(0); end if
  if (n38.ne.n39) then; write(0,*) 'n38.ne.n39'; call exit(0); end if
  if (n48.ne.n49) then; write(0,*) 'n48.ne.n49'; call exit(0); end if
  if (n58.ne.n59) then; write(0,*) 'n58.ne.n59'; call exit(0); end if
  if (n68.ne.n69) then; write(0,*) 'n68.ne.n69'; call exit(0); end if
  end if

  if (nfiles.ge.10) then
  if (n19.ne.n110) then; write(0,*) 'n19.ne.n110'; call exit(0); end if
  if (n29.ne.n210) then; write(0,*) 'n29.ne.n210'; call exit(0); end if
  if (n39.ne.n310) then; write(0,*) 'n39.ne.n310'; call exit(0); end if
  if (n49.ne.n410) then; write(0,*) 'n49.ne.n410'; call exit(0); end if
  if (n59.ne.n510) then; write(0,*) 'n59.ne.n510'; call exit(0); end if
  if (n69.ne.n610) then; write(0,*) 'n69.ne.n610'; call exit(0); end if
  end if

  if (nfiles.ge.11) then
  if (n110.ne.n111) then; write(0,*) 'n110.ne.n111'; call exit(0); end if
  if (n210.ne.n211) then; write(0,*) 'n210.ne.n211'; call exit(0); end if
  if (n310.ne.n311) then; write(0,*) 'n310.ne.n311'; call exit(0); end if
  if (n410.ne.n411) then; write(0,*) 'n410.ne.n411'; call exit(0); end if
  if (n510.ne.n511) then; write(0,*) 'n510.ne.n511'; call exit(0); end if
  if (n610.ne.n611) then; write(0,*) 'n610.ne.n611'; call exit(0); end if
  end if

  if (nfiles.ge.12) then
  if (n111.ne.n112) then; write(0,*) 'n111.ne.n112'; call exit(0); end if
  if (n211.ne.n212) then; write(0,*) 'n211.ne.n212'; call exit(0); end if
  if (n311.ne.n312) then; write(0,*) 'n311.ne.n312'; call exit(0); end if
  if (n411.ne.n412) then; write(0,*) 'n411.ne.n412'; call exit(0); end if
  if (n511.ne.n512) then; write(0,*) 'n511.ne.n512'; call exit(0); end if
  if (n611.ne.n612) then; write(0,*) 'n611.ne.n612'; call exit(0); end if
  end if

  if (nfiles.ge.13) then
  if (n112.ne.n113) then; write(0,*) 'n112.ne.n113'; call exit(0); end if
  if (n212.ne.n213) then; write(0,*) 'n212.ne.n213'; call exit(0); end if
  if (n312.ne.n313) then; write(0,*) 'n312.ne.n313'; call exit(0); end if
  if (n412.ne.n413) then; write(0,*) 'n412.ne.n413'; call exit(0); end if
  if (n512.ne.n513) then; write(0,*) 'n512.ne.n513'; call exit(0); end if
  if (n612.ne.n613) then; write(0,*) 'n612.ne.n613'; call exit(0); end if
  end if

  if (nfiles.ge.14) then
  if (n113.ne.n114) then; write(0,*) 'n113.ne.n14'; call exit(0); end if
  if (n213.ne.n214) then; write(0,*) 'n213.ne.n24'; call exit(0); end if
  if (n313.ne.n314) then; write(0,*) 'n313.ne.n34'; call exit(0); end if
  if (n413.ne.n414) then; write(0,*) 'n413.ne.n44'; call exit(0); end if
  if (n513.ne.n514) then; write(0,*) 'n513.ne.n54'; call exit(0); end if
  if (n613.ne.n614) then; write(0,*) 'n613.ne.n64'; call exit(0); end if
  end if


  if (nfiles.ge.15) then
  if (n114.ne.n115) then; write(0,*) 'n114.ne.n115'; call exit(0); end if
  if (n214.ne.n215) then; write(0,*) 'n214.ne.n215'; call exit(0); end if
  if (n314.ne.n315) then; write(0,*) 'n314.ne.n315'; call exit(0); end if
  if (n414.ne.n415) then; write(0,*) 'n414.ne.n415'; call exit(0); end if
  if (n514.ne.n515) then; write(0,*) 'n514.ne.n515'; call exit(0); end if
  if (n614.ne.n615) then; write(0,*) 'n614.ne.n615'; call exit(0); end if
  end if
  
  call to_history("n1",n1 )
  call to_history("n2",n2 )
  call to_history("n3",n3 )
  call to_history("n4",n4 )
  call to_history("n5",n5 )
  call to_history("n6",n6 )
  

  write(0,*) "n1,n2,n3,n4,n5,n6",n1,n2,n3,n4,n5,n6

  call sep_close()
  
  ! Allocate  
  allocate( trace (n1) )
  allocate( trace1(n1) )
  allocate( trace2(n1) )
  allocate( trace3(n1) )
  allocate( trace4(n1) )
  allocate( trace5(n1) )
  allocate( trace6(n1) )
  allocate( trace7(n1) )
  allocate( trace8(n1) )
  allocate( trace9(n1) )
  allocate( trace10(n1) )
  allocate( trace11(n1) )
  allocate( trace12(n1) )
  allocate( trace13(n1) )
  allocate( trace14(n1) )
  allocate( trace15(n1) )

  if (nfiles.eq.15) then
  if (norm) then; normval=15.; else; normval=1.; end if
  do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2;
    call sreed("file1",trace1,4*n1)
    call sreed("file2",trace2,4*n1)
    call sreed("file3",trace3,4*n1)
    call sreed("file4",trace4,4*n1)
    call sreed("file5",trace5,4*n1)
    call sreed("file6",trace6,4*n1)
    call sreed("file7",trace7,4*n1)
    call sreed("file8",trace8,4*n1)
    call sreed("file9",trace9,4*n1)
    call sreed("file10",trace10,4*n1)
    call sreed("file11",trace11,4*n1)
    call sreed("file12",trace12,4*n1)
    call sreed("file13",trace13,4*n1)
    call sreed("file14",trace14,4*n1)
    call sreed("file15",trace15,4*n1)
    trace = (trace1 + trace2 + trace3 + trace4 + trace5 + trace6 + trace7 + trace8 + trace9 + trace10 + trace11 + trace12 + trace13 + trace14 + trace15)/normval
    call srite("out"  ,trace ,4*n1)
  end do;      end do;      end do;      end do;      end do
  end if

  if (nfiles.eq.14) then
  if (norm) then; normval=14.; else; normval=1.; end if
  do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2;
    call sreed("file1",trace1,4*n1)
    call sreed("file2",trace2,4*n1)
    call sreed("file3",trace3,4*n1)
    call sreed("file4",trace4,4*n1)
    call sreed("file5",trace5,4*n1)
    call sreed("file6",trace6,4*n1)
    call sreed("file7",trace7,4*n1)
    call sreed("file8",trace8,4*n1)
    call sreed("file9",trace9,4*n1)
    call sreed("file10",trace10,4*n1)
    call sreed("file11",trace11,4*n1)
    call sreed("file12",trace12,4*n1)
    call sreed("file13",trace13,4*n1)
    call sreed("file14",trace14,4*n1)
    trace = (trace1 + trace2 + trace3 + trace4 + trace5 + trace6 + trace7 + trace8 + trace9 + trace10 + trace11 + trace12 + trace13 + trace14)/normval
    call srite("out"  ,trace ,4*n1)
  end do;      end do;      end do;      end do;      end do
  end if

  if (nfiles.eq.13) then
  if (norm) then; normval=13.; else; normval=1.; end if
  do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2;
    call sreed("file1",trace1,4*n1)
    call sreed("file2",trace2,4*n1)
    call sreed("file3",trace3,4*n1)
    call sreed("file4",trace4,4*n1)
    call sreed("file5",trace5,4*n1)
    call sreed("file6",trace6,4*n1)
    call sreed("file7",trace7,4*n1)
    call sreed("file8",trace8,4*n1)
    call sreed("file9",trace9,4*n1)
    call sreed("file10",trace10,4*n1)
    call sreed("file11",trace11,4*n1)
    call sreed("file12",trace12,4*n1)
    call sreed("file13",trace13,4*n1)
    trace = (trace1 + trace2 + trace3 + trace4 + trace5 + trace6 + trace7 + trace8 + trace9 + trace10 + trace11 + trace12 + trace13)/normval
    call srite("out"  ,trace ,4*n1)
  end do;      end do;      end do;      end do;      end do
  end if


  if (nfiles.eq.12) then
  if (norm) then; normval=12.; else; normval=1.; end if
  do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2;
    call sreed("file1",trace1,4*n1)
    call sreed("file2",trace2,4*n1)
    call sreed("file3",trace3,4*n1)
    call sreed("file4",trace4,4*n1)
    call sreed("file5",trace5,4*n1)
    call sreed("file6",trace6,4*n1)
    call sreed("file7",trace7,4*n1)
    call sreed("file8",trace8,4*n1)
    call sreed("file9",trace9,4*n1)
    call sreed("file10",trace10,4*n1)
    call sreed("file11",trace11,4*n1)
    call sreed("file12",trace12,4*n1)
    trace = (trace1 + trace2 + trace3 + trace4 + trace5 + trace6 + trace7 + trace8 + trace9 + trace10 + trace11 + trace12)/normval
    call srite("out"  ,trace ,4*n1)
  end do;      end do;      end do;      end do;      end do
  end if

  if (nfiles.eq.11) then
  if (norm) then; normval=11.; else; normval=1.; end if
  do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2;
    call sreed("file1",trace1,4*n1)
    call sreed("file2",trace2,4*n1)
    call sreed("file3",trace3,4*n1)
    call sreed("file4",trace4,4*n1)
    call sreed("file5",trace5,4*n1)
    call sreed("file6",trace6,4*n1)
    call sreed("file7",trace7,4*n1)
    call sreed("file8",trace8,4*n1)
    call sreed("file9",trace9,4*n1)
    call sreed("file10",trace10,4*n1)
    call sreed("file11",trace11,4*n1)
    trace = (trace1 + trace2 + trace3 + trace4 + trace5 + trace6 + trace7 + trace8 + trace9 + trace10 + trace11)/normval
    call srite("out"  ,trace ,4*n1)
  end do;      end do;      end do;      end do;      end do
  end if


  if (nfiles.eq.10) then
  if (norm) then; normval=10.; else; normval=1.; end if
  do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2;
    call sreed("file1",trace1,4*n1)
    call sreed("file2",trace2,4*n1)
    call sreed("file3",trace3,4*n1)
    call sreed("file4",trace4,4*n1)
    call sreed("file5",trace5,4*n1)
    call sreed("file6",trace6,4*n1)
    call sreed("file7",trace7,4*n1)
    call sreed("file8",trace8,4*n1)
    call sreed("file9",trace9,4*n1)
    call sreed("file10",trace10,4*n1)
    trace = (trace1 + trace2 + trace3 + trace4 + trace5 + trace6 + trace7 + trace8 + trace9 + trace10)/normval
    call srite("out"  ,trace ,4*n1)
  end do;      end do;      end do;      end do;      end do
  end if


  if (nfiles.eq.9) then
  if (norm) then; normval=9.; else; normval=1.; end if
  do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2;
    call sreed("file1",trace1,4*n1)
    call sreed("file2",trace2,4*n1)
    call sreed("file3",trace3,4*n1)
    call sreed("file4",trace4,4*n1)
    call sreed("file5",trace5,4*n1)
    call sreed("file6",trace6,4*n1)
    call sreed("file7",trace7,4*n1)
    call sreed("file8",trace8,4*n1)
    call sreed("file9",trace9,4*n1)
    trace = (trace1 + trace2 + trace3 + trace4 + trace5 + trace6 + trace7 + trace8 + trace9)/normval
    call srite("out"  ,trace ,4*n1)
  end do;      end do;      end do;      end do;      end do
  end if
  
  if (nfiles.eq.8) then
  if (norm) then; normval=8.; else; normval=1.; end if
  do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
    call sreed("file1",trace1,4*n1)
    call sreed("file2",trace2,4*n1)
    call sreed("file3",trace3,4*n1)
    call sreed("file4",trace4,4*n1)
    call sreed("file5",trace5,4*n1)
    call sreed("file6",trace6,4*n1)
    call sreed("file7",trace7,4*n1)
    call sreed("file8",trace8,4*n1)
    trace = (trace1 + trace2 + trace3 + trace4 + trace5 + trace6 + trace7 + trace8)/normval
    call srite("out"  ,trace ,4*n1)
  end do;      end do;      end do;      end do;      end do
  end if
  
  if (nfiles.eq.7) then
  if (norm) then; normval=7.; else; normval=1.; end if
  do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
    call sreed("file1",trace1,4*n1)
    call sreed("file2",trace2,4*n1)
    call sreed("file3",trace3,4*n1)
    call sreed("file4",trace4,4*n1)
    call sreed("file5",trace5,4*n1)
    call sreed("file6",trace6,4*n1)
    call sreed("file7",trace7,4*n1)
    trace = (trace1 + trace2 + trace3 + trace4 + trace5 + trace6 + trace7)/normval
    call srite("out"  ,trace ,4*n1)
  end do;      end do;      end do;      end do;      end do
  end if
  
  if (nfiles.eq.6) then
  if (norm) then; normval=6.; else; normval=1.; end if
  do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
    call sreed("file1",trace1,4*n1)
    call sreed("file2",trace2,4*n1)
    call sreed("file3",trace3,4*n1)
    call sreed("file4",trace4,4*n1)
    call sreed("file5",trace5,4*n1)
    call sreed("file6",trace6,4*n1)
    trace = (trace1 + trace2 + trace3 + trace4 + trace5 + trace6)/normval
    call srite("out"  ,trace ,4*n1)
  end do;      end do;      end do;      end do;      end do
  end if
  
  if (nfiles.eq.5) then
  if (norm) then; normval=5.; else; normval=1.; end if
  do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
    call sreed("file1",trace1,4*n1)
    call sreed("file2",trace2,4*n1)
    call sreed("file3",trace3,4*n1)
    call sreed("file4",trace4,4*n1)
    call sreed("file5",trace5,4*n1)
    trace = (trace1 + trace2 + trace3 + trace4 + trace5)/normval
    call srite("out"  ,trace ,4*n1)
  end do;      end do;      end do;      end do;      end do
  end if
  
  if (nfiles.eq.4) then
  if (norm) then; normval=4.; else; normval=1.; end if
  do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
    call sreed("file1",trace1,4*n1)
    call sreed("file2",trace2,4*n1)
    call sreed("file3",trace3,4*n1)
    call sreed("file4",trace4,4*n1)
    trace = (trace1 + trace2 + trace3 + trace4)/normval
    call srite("out"  ,trace ,4*n1)
  end do;      end do;      end do;      end do;      end do
  end if
  
  if (nfiles.eq.3) then
  if (norm) then; normval=3.; else; normval=1.; end if
   do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
    call sreed("file1",trace1,4*n1)
    call sreed("file2",trace2,4*n1)
    call sreed("file3",trace3,4*n1)
    trace = (trace1 + trace2 + trace3)/normval
    call srite("out"  ,trace ,4*n1)
  end do;      end do;      end do;      end do;      end do
  end if
  
  
  if (nfiles.eq.2) then
  if (norm) then; normval=2.; else; normval=1.; end if
  do nn=1,n6;  do mm=1,n5;  do ll=1,n4;  do kk=1,n3;  do jj=1,n2
    call sreed("file1",trace1,4*n1)
    call sreed("file2",trace2,4*n1)
    trace = (trace1 + trace2)/normval
    call srite("out"  ,trace ,4*n1)
  end do;      end do;      end do;      end do;      end do
  end if
  
  ! Deallocate  
  deallocate(trace )
  deallocate(trace1)
  deallocate(trace2)
  deallocate(trace3)
  deallocate(trace4)
  deallocate(trace5)
  deallocate(trace6)
  deallocate(trace7)
  deallocate(trace8)
  deallocate(trace9)
  
  call exit(0)
  
end program
