program sdrSetSparseFlag
  ! program to make a 3D dataset sparse, by excluding all dead traces.
  ! My frst SEP3d program
  
  use sep
  implicit none
  
  integer          :: n1,n2,n3,n4,n5
  real             :: d1,d2,d3
  real             :: o1,o2,o3
  
  real,allocatable :: data(:),header(:,:)
  
  integer          :: ntrs,nhdrs     ! datalength,headerlength and number of traces
  integer          :: dkey           ! Which key to check
  real             :: dval
  
  integer          :: ii
  
  call sep_init()
  
  call from_aux('data','n1',n1,0)
  call from_aux('data','n2',n2,0)
  call from_aux('data','n3',n3,1)
  call from_aux('data','n4',n4,1)
  call from_aux('data','n5',n5,1)
  ntrs = n2*n3*n4*n5

  call from_history('n1',nhdrs,1)

  call from_param('deadkey',dkey,nhdrs )
  call from_param('deadval',dval,30000.)

  call sep_close()
  
  write(0,*) 'n1,n2,n3,n4'
  write(0,*)  n1,n2,n3,n4
  
  ! Allocate memory
  allocate(data(n1),header(nhdrs,ntrs)); data=0.; header=0.
  
  ! Read header
  call sreed('in'  ,header,4*nhdrs*ntrs )
  
  ! Check if trace dead (by energy in trace)
  do ii=1,ntrs
    data = 0.;
    call sreed('data',data   , 4*n1    )
   ! write(0,*) 'ii', ii,size(data),data
    
    ! Write another header
    if (sum(abs(data(:))).eq.0.) then
  !    write(0,*) 'Detected sparse:',ii
      header(dkey,ii)=dval
    end if
 !   header(1   ,ii)=ii

  end do
  
  ! Write header
  call srite('out',header,4*nhdrs*ntrs )
  
  ! Deallocate memory
  deallocate(data,header)
  
end program
