program sdrFFTshift1d
! Tape a datafile

  use sep                      ! Main SEP module
  use fftshift_mod

  implicit none
  
  real, allocatable               :: data_in (:,:,:)
  real, allocatable               :: data_out(:,:,:)
  integer                         :: n(3),n4,n5,n6,n7,ll,mm,nn,oo
  integer                         :: dir
  logical                         :: adj
  
  ! Open I/O headerfiles
  call sep_init()              ! Call to SEP module 
    
  ! Read input parameters for taper, there is lots of options :-)
  call from_param ("dir" ,dir,   1    )
  call from_param ("adj" ,adj,.false. )
  
  call from_history("n1", n(1) )
  call from_history("n2", n(2) )
  call from_history("n3", n(3) )
  call from_history("n4", n4,1 )
  call from_history("n5", n5,1 )
  call from_history("n6", n6,1 )
  call from_history("n7", n7,1 )
  
  ! Close properly
  call sep_close ()            ! Close all I/O to headerfiles
  
  ! Allocate the arrays datain & dataout
  allocate ( data_in(n(1),n(2),n(3)),data_out(n(1),n(2),n(3)) )
  
  do oo=1,n7; do nn=1,n6; do mm=1,n5; do ll=1,n4

  ! Read in data from input file
  if (adj) then;
    call sep_read  (data_out)
  else;
    call sep_read  (data_in )
  end if
  
  ! Execute FFTshift
  if (dir.eq.1) then
    call fftshift1d_1_lop(adj,.false.,data_in,data_out)
  end if
  if (dir.eq.2) then
    call fftshift1d_2_lop(adj,.false.,data_in,data_out)
  end if
  if (dir.eq.3) then
    call fftshift1d_3_lop(adj,.false.,data_in,data_out)
  end if
  
  ! Write data to output file
  if (adj) then;
    call sep_write (data_in )
  else;
    call sep_write (data_out)
  end if

  end do;   end do;   end do;   end do; 
  
  ! Deallocate memory
  deallocate     (data_in,data_out)
  
  ! Force clean exit
  call exit (0)
  
end program

