program sdrFFTshiftmd
! Tape a datafile

  use sep                      ! Main SEP module
  use fftshift_mod
  implicit none
  
  real, allocatable               :: data_in (:,:,:)
  real, allocatable               :: data_out(:,:,:)
  integer                         :: n(3)
  integer                         :: dir
  logical                         :: adj
  
  ! Open I/O headerfiles
  call sep_init()              ! Call to SEP module 
    
  ! Read input parameters for taper, there is lots of options :-)
  call from_param ("dir" ,dir,   1    )
  call from_param ("adj" ,adj,.false. )
  
  call from_history("n1", n(1) )
  call from_history("n2", n(2) )
  call from_history("n3", n(3) )
  
  ! Close properly
  call sep_close ()            ! Close all I/O to headerfiles
  
  ! Allocate the arrays datain & dataout
  allocate ( data_in(n(1),n(2),n(3)),data_out(n(1),n(2),n(3)) )
  
  ! Read in data from input file
  if (adj) then;
    call sep_read  (data_out)
  else;
    call sep_read  (data_in )
  end if
  
  ! Execute FFTshift
  if (n(3).gt.1) then
    call fftshift3d_lop(adj,.false.,data_in(:,:,:),data_out(:,:,:))
  else
    call fftshift3d_lop(adj,.false.,data_in(:,:,1),data_out(:,:,1))
  end if
  
  ! Write data to output file
  if (adj) then;
    call sep_write (data_in )
  else;
    call sep_write (data_out)
  end if
  
  ! Deallocate memory
  deallocate     (data_in,data_out)
  
  ! Force clean exit
  call exit (0)
  
end program

