program sdrMTFFT1d
  ! Tape a datafile
  
  use sep                      ! Main SEP module
  use mt_fftw_mod
  implicit none
  
  real, allocatable               :: data_in (:,:,:)
  complex,allocatable             :: data_out(:,:,:,:)
  integer                         :: n(3),nw
  real                            :: d(3),o(3),dw
  logical                         :: adj
  integer                         :: ii
  real                            :: tbp
  integer                         :: nt
  character*50                    :: labels(3)
  
  ! Open I/O headerfiles
  call sep_init()              ! Call to SEP module 
  
  ! Read input parameters for taper, there is lots of options :-)
  call from_param ("adj" ,adj,.false. )
  call from_param ("tbp" ,tbp,   10.  )
   
  if (adj) then;
    call from_history("n2",  nt  )
    call from_history("n3", n(2) )
    call from_history("n4", n(3) )
    call from_history("d2", d(2) )
    call from_history("d3", d(3) )
    call from_history("o2", o(2) )
    call from_history("o3", o(3) )
    call from_history("label1", labels(1) )
    call from_history("label2", labels(2) )
    call from_history("label3", labels(3) )
    call from_history("n1", nw   )
    call from_history("d1", dw   )
    call mt_fft_r2c_units_t(adj,nt=n(1),dt=d(1),nw=nw,dw=dw)
    call mt_fft_r2c_units_t(adj,nt=n(1),dt=d(2),nw=nw,dw=dw)
    call mt_fft_r2c_units_t(adj,nt=n(1),dt=d(3),nw=nw,dw=dw)
    call to_history("n1",    n(1) )
    call to_history("d1",    d(1) )
    call to_history("o1",    0.   )
    call to_history("esize", 4    )
    call to_history("n2", n(2) )
    call to_history("n3", n(3) )
    call to_history("n4",   1  )
    call to_history("d2", d(2) )
    call to_history("d3", d(3) )
    call to_history("d4",  1.  )
    call to_history("o2", o(2) )
    call to_history("o3", o(3) )
    call to_history("o4",  0.  )
    call to_history("label1", labels(1) )
    call to_history("label2", labels(2) )
    call to_history("label3", labels(3) )
    call to_history("label4",    " "    )
  else
    call from_param  ("nt", nt, 4 )
    call from_history("n2", n(2) )
    call from_history("n3", n(3) )
    call from_history("d2", d(2) )
    call from_history("d3", d(3) )
    call from_history("o2", o(2) )
    call from_history("o3", o(3) )
    call from_history("label1", labels(1) )
    call from_history("label2", labels(2) )
    call from_history("label3", labels(3) )
    call from_history("n1", n(1) )
    call from_history("d1", d(1) )
    call mt_fft_r2c_units_t(adj,nt=n(1),dt=d(1),nw=nw,dw=dw)
    call to_history("n1",    nw  )
    call to_history("d1",    dw  )
    call to_history("o1",    0.  )
    call to_history("esize", 8   )
    call to_history("n2", nt   )
    call to_history("n3", n(2) )
    call to_history("n4", n(3) )
    call to_history("d2",   1. )
    call to_history("d3", d(2) )
    call to_history("d4", d(3) )
    call to_history("o2",   0  )
    call to_history("o3", o(2) )
    call to_history("o4", o(3) )
    call to_history("label1", labels(1) )
    call to_history("label2", "taper"   )
    call to_history("label3", labels(2) )
    call to_history("label4", labels(3) )
  end if
  
  ! Close properly
  call sep_close ()            ! Close all I/O to headerfiles
  
  ! Allocate the arrays datain & dataout, and Initalize the Module
  allocate ( data_in(n(1),n(2),n(3)),data_out(nw ,nt,n(2),n(3)) )
  ! Initialize the FFTW functions
  call mt_fftw1d_1_r2c_lop_init(nt_in=n(1),nk_in=nt,tbp_in=tbp)

  ! Read in data from input file
  if (adj) then;
    call sep_read  (data_out)
  else;
    call sep_read  (data_in )
  end if
  
  ! Execute MT FFT
  call mt_fftw1d_1_r2c_lop(adj,.false.,data_in,data_out)

  ! Write data to output file
  if (adj) then;
    call sep_write (data_in )
  else;
    call sep_write (data_out)
  end if
  
  ! Deallocate memory
  deallocate     (data_in,data_out)
  call mt_fftw1d_1_r2c_lop_close()
  
  ! Force clean exit
  call exit (0)
  
end program

