! Calculate Single Taper Spectrum in 1d (F domain input)
program sdrMTSpectra_w
  ! types (stype):
  ! 1 - amplitude
  ! 2 - power (ampl**2)

  use sep
  use mtspectra_mod

  implicit none

  complex,allocatable         :: data_in (:,:,:,:)
  real,allocatable            :: data_out(:,:,:)
  integer                     :: n1,n2,n3,n4,n5,nt
  real                        :: d1,d2,d3,o1,o2,o3
  integer                     :: ll,mm,dir
  integer                     :: type

  call sep_init()

  call from_param("dir",dir,1)

  if (dir.eq.1) then
    call from_history("n1",n1,1)
    call from_history("n2",nt,1)
    call from_history("n3",n2,1)
    call from_history("n4",n3,1)
  end if
  if (dir.eq.1) then
    call from_history("n1",n1,1)
    call from_history("n2",n2,1)
    call from_history("n3",nt,1)
    call from_history("n4",n3,1)
  end if
  if (dir.eq.1) then
    call from_history("n1",n1,1)
    call from_history("n2",n2,1)
    call from_history("n3",n3,1)
    call from_history("n4",nt,1)
  end if

  call from_history("n5",n4,1)
  call from_history("n6",n5,1)

  call to_history  ("esize",4)
  call to_history  ("n2",n2)
  call to_history  ("n3",n3)
  call to_history  ("n4",n4)
  call to_history  ("n5",n5)

  call from_param("stype",type,1)   ! 1: ampl, 2:powr

  call sep_close()

  if (dir.eq.1) then;  allocate( data_in(n1,nt,n2,n3) , data_out(n1,n2,n3) );  end if
  if (dir.eq.2) then;  allocate( data_in(n1,n2,nt,n3) , data_out(n1,n2,n3) );  end if
  if (dir.eq.3) then;  allocate( data_in(n1,n2,n3,nt) , data_out(n1,n2,n3) );  end if


  if (type.eq.1) then

    do mm=1,n5; do ll=1,n4
    ! Read Data
    call sreed("in" ,data_in ,8*size(data_in ))
    ! Compute Spectrum
    if (dir.eq.1) then;  call mtspectra_1_ampl(data_in,data_out);  end if
    if (dir.eq.2) then;  call mtspectra_2_ampl(data_in,data_out);  end if
    if (dir.eq.3) then;  call mtspectra_3_ampl(data_in,data_out);  end if
    ! Write Data
    call srite("out",data_out,4*size(data_out))
    end do;     end do
    
  else

    do mm=1,n5; do ll=1,n4
    ! Read Data
    call sreed("in" ,data_in ,8*size(data_in ))
    ! Compute Spectrum
    if (dir.eq.1) then;  call mtspectra_1_powr(data_in,data_out);  end if
    if (dir.eq.2) then;  call mtspectra_2_powr(data_in,data_out);  end if
    if (dir.eq.3) then;  call mtspectra_3_powr(data_in,data_out);  end if
    ! Write Data
    call srite("out",data_out,4*size(data_out))
    end do;     end do
    
  end if

  deallocate( data_in , data_out )

end program
