program test_cmlpx_sum

  use sep

  integer             :: ii
  integer             :: array_size,value
  complex             :: res1,res2,res3
  complex,allocatable :: array(:)
  double precision    :: t1,t2,s1,s2

  call sep_init()
  call from_param( "array_size",array_size,10)
  call from_param( "value"     ,  value   ,10)
  call sep_close()

  write(0,*) "From Parameter:"
  write(0,*) "array_size: ", array_size
  write(0,*) "value: ", value    
  allocate( array(array_size) )
  array = cmplx(real(value),real(value))

  write(0,*) " "
  write(0,*) "From Compile and system:"
  write(0,*) "HUGE(array_size): ", HUGE(array_size)
  write(0,*) "HUGE(real(array_size)): ", HUGE(real(array_size))
  write(0,*) "HUGE(value): ", HUGE(value)
  write(0,*) "HUGE(real(value)): ", HUGE(real(value))
  
  
  ! First Method
  res1=sum(array)/size(array)

  ! Second Method
  res2=cmplx( real(sum( dble(real(array)) ) /dble(size(array))) , real(sum( dble(aimag(array)) ) /dble(size(array)) )  )
  
  ! Third Method
  s1=0
  s2=0
  do ii=1,size(array)
    t1= real(array(ii))
    t2=aimag(array(ii))
    s1=s1+t1
    s2=s2+t2
  end do
  s1=s1/size(array)
  s2=s2/size(array)
  res3=cmplx(s1,s2)
  
  write(0,*) " "
  write(0,*) "Calculations:"
  write(0,*) "size(array): ",size(array)
  write(0,*) "res1: ",res1
  write(0,*) "res2: ",res2
  write(0,*) "res3: ",res3

  deallocate( array )

end program
