program ConvertWF
  
  use sep
  implicit none
  
  integer           :: n1,n2,n3,n4,n5,n6,esize
  real              :: d1,o1
  logical           :: adj,cmplx
  real, parameter   :: pi = 3.14159265
  
  real,allocatable    :: data_real(:,:,:,:,:,:)
  complex,allocatable :: data_cmplx(:,:,:,:,:,:)
  
  call sep_init()
  
  call from_param ("adj"   ,adj  ,.false. )
  
  call from_history("n1",n1,1 )
  call from_history("n2",n2,1 )
  call from_history("n3",n3,1 )
  call from_history("n4",n4,1 )
  call from_history("n5",n5,1 )
  call from_history("n6",n6,1 )
  call from_history("d1",d1,1.)
  call from_history("o1",o1,0.)
 
  call from_history("esize",esize,4)
  
  if (adj) then
    d1 = d1/2./pi
    o1 = o1/2./pi
  else
    d1 = d1*2.*pi
    o1 = o1*2.*pi
  end if
  
  call to_history("n1",n1)
  call to_history("d1",d1)
  call to_history("o1",o1)
  
  call sep_close()
  
  if (esize.eq.4) then
    write(0,*) "Detected real"
    allocate(data_real(n1,n2,n3,n4,n5,n6))
    call sreed("in" ,data_real,esize*size(data_real))
    call srite("out",data_real,esize*size(data_real))
    deallocate(data_real)
  else if (esize.eq.8) then
    write(0,*) "Detected cmplx"
    allocate(data_cmplx(n1,n2,n3,n4,n5,n6))
    call sreed("in" ,data_cmplx,esize*size(data_cmplx))
    call srite("out",data_cmplx,esize*size(data_cmplx))
    deallocate(data_cmplx)
  end if
  
  call exit(0)
  
end program
