program sdrFlipPolarity

  use sep
  implicit none

  ! Axis variables
  integer       :: n1,n2,n3,n4,n5,n6
  !real          :: d1,d2,d3,d4,d5,d6
  !real          :: o1,o2,o3,o4,o5,o6

  ! Optimization variables
  integer       :: ii,jj,kk,ll,mm,nn

  ! Parameters
  real          :: norm_scale,max_value

  ! Memory Variables
  real,allocatable  :: DATAIN (:,:,:,:,:,:)

  call sep_init()

  ! Read from History
  call from_history("n1",n1,1 )
  call from_history("n2",n2,1 )
  call from_history("n3",n3,1 )
  call from_history("n4",n4,1 )
  call from_history("n5",n5,1 )
  call from_history("n6",n6,1 )

  ! Read from parameter
  call from_param("scale",norm_scale,1.)
  
  call sep_close()
  
  
  ! Allocate Memory
  allocate( DATAIN (n1,n2,n3,n4,n5,n6) )
  
  ! Read Data
  call sreed("in",DATAIN ,4*size(DATAIN))
  
  ! Determine maximum value
  max_value = maxval(DATAIN)
  
  ! Rescale
  if ( norm_scale .ne. 1. ) then
    do nn=1,n6
    do mm=1,n5
    do ll=1,n4
    do kk=1,n3
    do jj=1,n2
    do ii=1,n1
      DATAIN(ii,jj,kk,ll,mm,nn) = DATAIN(ii,jj,kk,ll,mm,nn)/max_value*norm_scale
    end do
    end do
    end do
    end do
    end do
    end do

    ! Flip Polarity
    do nn=1,n6
    do mm=1,n5
    do ll=1,n4
    do kk=1,n3
    do jj=1,n2
    do ii=1,n1
      DATAIN(ii,jj,kk,ll,mm,nn) = norm_scale - DATAIN(ii,jj,kk,ll,mm,nn)
    end do
    end do
    end do
    end do
    end do
    end do
    
  else
    
    ! Flip Polarity
    do nn=1,n6
    do mm=1,n5
    do ll=1,n4
    do kk=1,n3
    do jj=1,n2
    do ii=1,n1
      DATAIN(ii,jj,kk,ll,mm,nn) = max_value - DATAIN(ii,jj,kk,ll,mm,nn)
    end do
    end do
    end do
    end do
    end do
    end do
    
  end if


  ! Write Data
  call srite("out",DATAIN,4*size(DATAIN))

  ! Deallocate Memory
  deallocate( DATAIN )

end program
