program MHmask
  ! program to apply a mask to zero the outerbounds
  ! of the MH domain, that is retrieved from a
  ! 'full' SR domain.

  use sep
  implicit none


  integer            :: n1,n2,n3,n4,n5
  real               :: o1,o2,o3
  real               :: d1,d2,d3

  integer            :: im,ih,kk,ll,mm

  real,allocatable   :: data(:,:,:)

  call sep_init()

  call from_history("n1",n1,1 )
  call from_history("n2",n2,1 )
  call from_history("n3",n3,1 )

  call from_history("d1",d1,1.)
  call from_history("d2",d2,1.)
  call from_history("d3",d3,1.)

  call from_history("o1",o1,0.)
  call from_history("o2",o2,0.)
  call from_history("o3",o3,0.)

  call from_history("n4",n4,1 )
  call from_history("n5",n5,1 )

  call sep_close()

  allocate(data(n1,n2,n3))

  do kk=1,n5
  do ll=1,n4
      
      call sreed("in",data,4*size(data))
      
      do im=1,n2
      do ih=1,n3
          
          if ((im+(ih-n2/2)  ).lt.1) then
            data(:,im,ih) = 0.
          end if
          
          if ((im-(ih-n2/2)+1).lt.1) then
            data(:,im,ih) = 0.
          end if
          
          if ((im-(ih-n2/2)  ).gt.n3) then
            data(:,im,ih) = 0.
          end if
          
          if ((im+(ih-n2/2)  ).gt.n2) then
            data(:,im,ih) = 0.
          end if
          
      end do
      end do

      call srite("out",data,4*size(data))

  end do
  end do

  deallocate(data)

  call exit(0)

end program
