program sdrMTapers

  use sep                      ! Main SEP module
  use mtapers_mod

  implicit none
  
  real, allocatable               :: mtaper(:,:)
  integer                         :: n(2), ii
  real                            :: d(3),o(3)
  real                            :: t1,t2
  integer                         :: t1_ind,t2_ind
  logical                         :: inv
  real                            :: scale,tbp
  
  ! Open I/O headerfiles
  call sep_init   ()            ! Call to SEP module 
  
  ! read from input .H file or parameter
  call from_param ("n1",n(1),1024)
  call from_param ("nt",n(2),1   )
  call from_param ("d1",d(1),1.  )
  call from_param ("o1",o(1),0.  )
  
  ! Read input parameters for taper, there is lots of options :-)
  call from_param ("inv"  ,inv,.false. )
  call from_param ("tbp"  ,tbp,   10.  )
  call from_param ("scale",scale,  1.  )
  
  call from_param ("t1",t1, o(1)                     )
  call from_param ("t2",t2, o(1) + d(1)*real(n(1)-1) )
  
  ! Write to auxiliary .H file
  call to_history ("n1",n(1))  
  call to_history ("n2",n(2))
  call to_history ("n3",  1 )
  call to_history ("d1",d(1))
  call to_history ("d2",  1.)
  call to_history ("d3",  1.)
  call to_history ("o1",o(1))
  call to_history ("o2",  0.)
  
  ! Close properly
  call sep_close  ()            ! Close all I/O to headerfiles
  
  ! Determine tie indices
  do ii=1,3
    call mtapers_indice( t1,t1_ind,d_in=d(1),o_in=o(1) )
    call mtapers_indice( t2,t2_ind,d_in=d(1),o_in=o(1) )
  end do
  
  ! Allocate Taper Space
  allocate ( mtaper(n(1),n(2) ) )
  call mtapers_init(n1_in=n(1) ,nt_in=n(2) )
  call mtapers_interface(.false.,t1_in=t1_ind,t2_in=t2_ind,scale_in=scale,inv_in=inv,tbp_in=tbp)
  call mtapers_gettaper(mtaper_out=mtaper)
  call mtapers_close()

  ! write out mtaper  
  call sep_write(   mtaper   )

  ! Deallocate memory
  deallocate(     mtaper     )
  
  ! Force clean exit
  call exit (0)
  
end program


