program maindemean

  use sep                      ! Main SEP module
  use padd_mod
  implicit none

  integer                          :: n1, n2, n3, n4, n5, p1,p2,p3
  real                             :: d1, d2, d3, d4, o1, o2, o3, o4
  integer                          :: ll,mm
  real,allocatable                 :: data_in(:,:,:),data_out(:,:,:)
  logical                          :: adj,center
  integer                          :: centint
  
  ! History and Parameter I/O
  call sep_init()
  call from_param('adj'   ,adj   ,.false.)
  call from_param('center',center,.false.)

  if (adj) then
    call from_history( 'p1', n1, 0 )
    call from_history( 'p2', n2, 0 )
    call from_history( 'p3', n3, 0 )
    call from_param  ( 'n1', p1, 0 )
    call from_param  ( 'n2', p2, 0 )
    call from_param  ( 'n3', p3, 0 )
    if (p1.eq.0) then; call from_history( 'n1', p1, n1 ); end if;
    if (p2.eq.0) then; call from_history( 'n2', p2, n2 ); end if;
    if (p3.eq.0) then; call from_history( 'n3', p3, n3 ); end if;
    call to_history('n1', n1)
    call to_history('n2', n2)
    call to_history('n3', n3)
    call to_history('p1', p1)
    call to_history('p2', p2)
    call to_history('p3', p3)
    call from_history('center',centint,0);
    if (centint.eq.1) then; center=.true.; else; center=.false.; end if;
  else
    call from_history( 'n1', n1, 0 )
    call from_history( 'n2', n2, 0 )
    call from_history( 'n3', n3, 0 )
    call from_param  ( 'p1', p1, 0 )
    call from_param  ( 'p2', p2, 0 )
    call from_param  ( 'p3', p3, 0 )
    if (p1.eq.0) then; call from_history( 'p1', p1, n1 ); end if;
    if (p2.eq.0) then; call from_history( 'p2', p2, n2 ); end if;
    if (p3.eq.0) then; call from_history( 'p3', p3, n3 ); end if;
    call to_history('n1', p1)
    call to_history('n2', p2)
    call to_history('n3', p3)
    call to_history('p1', n1)
    call to_history('p2', n2)
    call to_history('p3', n3)
    if (center) then; centint=1; else; centint=0; end if;
  end if

  call from_history('n4',n4,1 )
  call from_history('n5',n5,1 )
  call sep_close()

  ! Allocate the arrays datain & dataout, and Initalize the Module
  allocate ( data_in(n1,n2,n3),data_out(p1,p2,p3) )
  call padd_mod_init(center_in=center,p1_in=p1,p2_in=p2,p3_in=p3)

  do mm=1,n5
  do ll=1,n4

    ! Read in data from input file
    if (adj) then;
      call sep_read  (data_out)
    else;
      call sep_read  (data_in )
    end if
  
    ! Execute MD FFT
    if      (n1.ne.1 .and. n2.eq.1 .and. n3.eq.1) then
      call padd_lop(adj,.false.,data_in(:,1,1),data_out(:,1,1))
    else if (n1.ne.1 .and. n2.ne.1 .and. n3.eq.1) then
      call padd_lop(adj,.false.,data_in(:,:,1),data_out(:,:,1))
    else if (n1.ne.1 .and. n2.ne.1 .and. n3.ne.1) then
      call padd_lop(adj,.false.,data_in(:,:,:),data_out(:,:,:))
    end if
  
    ! Write data to output file
    if (adj) then;
      call sep_write (data_in )
    else;
      call sep_write (data_out)
    end if

  
    ! Force clean exit
    call exit (0)

  end do
  end do


  ! Deallocate memory
  deallocate     (data_in,data_out)
  call padd_mod_close()

  call exit(0)
  
end program maindemean
